VTK: vtkSphereWidget Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
vtkSphereWidget Class Reference

3D widget for manipulating a sphere More...

`#include <vtkSphereWidget.h>`

Inheritance diagram for vtkSphereWidget:
[legend]
Collaboration diagram for vtkSphereWidget:
[legend]

## Public Types
typedef vtk3DWidget | Superclass
Public Types inherited from vtk3DWidget
typedef vtkInteractorObserver | Superclass
Public Types inherited from vtkInteractorObserver
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkSphereWidget * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetThetaResolution (int r)
| Set/Get the resolution of the sphere in the Theta direction. More...
int | GetThetaResolution ()
void | SetPhiResolution (int r)
| Set/Get the resolution of the sphere in the Phi direction. More...
int | GetPhiResolution ()
void | GetPolyData (vtkPolyData *pd)
| Grab the polydata (including points) that defines the sphere. More...
void | GetSphere (vtkSphere *sphere)
| Get the spherical implicit function defined by this widget. More...
void | SetEnabled (int) override
| Methods that satisfy the superclass' API. More...
void | PlaceWidget (double bounds[6]) override
| Methods that satisfy the superclass' API. More...
void | PlaceWidget () override
| Methods that satisfy the superclass' API. More...
void | PlaceWidget (double xmin, double xmax, double ymin, double ymax, double zmin, double zmax) override
| Methods that satisfy the superclass' API. More...
virtual void | SetRepresentation (int)
| Set the representation of the sphere. More...
virtual int | GetRepresentation ()
| Set the representation of the sphere. More...
void | SetRepresentationToOff ()
| Set the representation of the sphere. More...
void | SetRepresentationToWireframe ()
| Set the representation of the sphere. More...
void | SetRepresentationToSurface ()
| Set the representation of the sphere. More...
void | SetRadius (double r)
| Set/Get the radius of sphere. More...
double | GetRadius ()
| Set/Get the radius of sphere. More...
void | SetCenter (double x, double y, double z)
| Set/Get the center of the sphere. More...
void | SetCenter (double x[3])
| Set/Get the center of the sphere. More...
double * | GetCenter ()
| Set/Get the center of the sphere. More...
void | GetCenter (double xyz[3])
| Set/Get the center of the sphere. More...
virtual void | SetTranslation (vtkTypeBool)
| Enable translation and scaling of the widget. More...
virtual vtkTypeBool | GetTranslation ()
| Enable translation and scaling of the widget. More...
virtual void | TranslationOn ()
| Enable translation and scaling of the widget. More...
virtual void | TranslationOff ()
| Enable translation and scaling of the widget. More...
virtual void | SetScale (vtkTypeBool)
| Enable translation and scaling of the widget. More...
virtual vtkTypeBool | GetScale ()
| Enable translation and scaling of the widget. More...
virtual void | ScaleOn ()
| Enable translation and scaling of the widget. More...
virtual void | ScaleOff ()
| Enable translation and scaling of the widget. More...
virtual void | SetHandleVisibility (vtkTypeBool)
| The handle sits on the surface of the sphere and may be moved around the surface by picking (left mouse) and then moving. More...
virtual vtkTypeBool | GetHandleVisibility ()
| The handle sits on the surface of the sphere and may be moved around the surface by picking (left mouse) and then moving. More...
virtual void | HandleVisibilityOn ()
| The handle sits on the surface of the sphere and may be moved around the surface by picking (left mouse) and then moving. More...
virtual void | HandleVisibilityOff ()
| The handle sits on the surface of the sphere and may be moved around the surface by picking (left mouse) and then moving. More...
virtual void | SetHandleDirection (double, double, double)
| Set/Get the direction vector of the handle relative to the center of the sphere. More...
virtual void | SetHandleDirection (double[3])
| Set/Get the direction vector of the handle relative to the center of the sphere. More...
virtual double * | GetHandleDirection ()
| Set/Get the direction vector of the handle relative to the center of the sphere. More...
virtual void | GetHandleDirection (double &, double &, double &)
| Set/Get the direction vector of the handle relative to the center of the sphere. More...
virtual void | GetHandleDirection (double[3])
| Set/Get the direction vector of the handle relative to the center of the sphere. More...
virtual double * | GetHandlePosition ()
| Get the position of the handle. More...
virtual void | GetHandlePosition (double &, double &, double &)
| Get the position of the handle. More...
virtual void | GetHandlePosition (double[3])
| Get the position of the handle. More...
virtual vtkProperty * | GetSphereProperty ()
| Get the sphere properties. More...
virtual vtkProperty * | GetSelectedSphereProperty ()
| Get the sphere properties. More...
virtual vtkProperty * | GetHandleProperty ()
| Get the handle properties (the little ball on the sphere is the handle). More...
virtual vtkProperty * | GetSelectedHandleProperty ()
| Get the handle properties (the little ball on the sphere is the handle). More...
Public Member Functions inherited from vtk3DWidget
vtk3DWidget * | NewInstance () const
virtual void | SetProp3D (vtkProp3D *)
| Specify a vtkProp3D around which to place the widget. More...
virtual vtkProp3D * | GetProp3D ()
| Specify a vtkProp3D around which to place the widget. More...
virtual void | SetInputData (vtkDataSet *)
| Specify the input dataset. More...
virtual void | SetInputConnection (vtkAlgorithmOutput *)
| Specify the input dataset. More...
virtual vtkDataSet * | GetInput ()
| Specify the input dataset. More...
virtual void | SetPlaceFactor (double)
| Set/Get a factor representing the scaling of the widget upon placement (via the PlaceWidget() method). More...
virtual double | GetPlaceFactor ()
| Set/Get a factor representing the scaling of the widget upon placement (via the PlaceWidget() method). More...
virtual void | SetHandleSize (double)
| Set/Get the factor that controls the size of the handles that appear as part of the widget. More...
virtual double | GetHandleSize ()
| Set/Get the factor that controls the size of the handles that appear as part of the widget. More...
Public Member Functions inherited from vtkInteractorObserver
vtkInteractorObserver * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | GetEnabled ()
void | EnabledOn ()
void | EnabledOff ()
void | On ()
void | Off ()
virtual void | OnChar ()
| Sets up the keypress-i event. More...
virtual void | SetInteractor (vtkRenderWindowInteractor *iren)
| This method is used to associate the widget with the render window interactor. More...
virtual vtkRenderWindowInteractor * | GetInteractor ()
| This method is used to associate the widget with the render window interactor. More...
virtual void | SetPriority (float)
| Set/Get the priority at which events are processed. More...
virtual float | GetPriority ()
| Set/Get the priority at which events are processed. More...
virtual void | PickingManagedOn ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | PickingManagedOff ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | SetPickingManaged (bool managed)
| Enable/Disable the use of a manager to process the picking. More...
virtual bool | GetPickingManaged ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | SetKeyPressActivation (vtkTypeBool)
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual vtkTypeBool | GetKeyPressActivation ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | KeyPressActivationOn ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | KeyPressActivationOff ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | SetKeyPressActivationValue (char)
| Specify which key press value to use to activate the interactor observer (if key press activation is enabled). More...
virtual char | GetKeyPressActivationValue ()
| Specify which key press value to use to activate the interactor observer (if key press activation is enabled). More...
virtual vtkRenderer * | GetDefaultRenderer ()
| Set/Get the default renderer to use when activating the interactor observer. More...
virtual void | SetDefaultRenderer (vtkRenderer *)
| Set/Get the default renderer to use when activating the interactor observer. More...
virtual vtkRenderer * | GetCurrentRenderer ()
| Set/Get the current renderer. More...
virtual void | SetCurrentRenderer (vtkRenderer *)
| Set/Get the current renderer. More...
void | GrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods enable an interactor observer to exclusively grab all events invoked by its associated vtkRenderWindowInteractor. More...
void | ReleaseFocus ()
| These methods enable an interactor observer to exclusively grab all events invoked by its associated vtkRenderWindowInteractor. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkSphereWidget * | New ()
| Instantiate the object. More...
static vtkTypeBool | IsTypeOf (const char *type)
static vtkSphereWidget * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtk3DWidget
static vtkTypeBool | IsTypeOf (const char *type)
static vtk3DWidget * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkInteractorObserver
static vtkTypeBool | IsTypeOf (const char *type)
static vtkInteractorObserver * | SafeDownCast (vtkObjectBase *o)
static void | ComputeDisplayToWorld (vtkRenderer *ren, double x, double y, double z, double worldPt[4])
| Convenience methods for outside classes. More...
static void | ComputeWorldToDisplay (vtkRenderer *ren, double x, double y, double z, double displayPt[3])
| Convenience methods for outside classes. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Types
enum | WidgetState { Start = 0 , Moving , Scaling , Positioning , Outside }

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkSphereWidget ()
| ~vtkSphereWidget () override
void | OnLeftButtonDown ()
void | OnLeftButtonUp ()
void | OnRightButtonDown ()
void | OnRightButtonUp ()
void | OnMouseMove ()
void | HighlightSphere (int highlight)
void | SelectRepresentation ()
void | RegisterPickers () override
| Register internal Pickers in the Picking Manager. More...
void | Translate (double *p1, double *p2)
void | ScaleSphere (double *p1, double *p2, int X, int Y)
void | MoveHandle (double *p1, double *p2, int X, int Y)
void | PlaceHandle (double *center, double radius)
void | CreateDefaultProperties ()
void | HighlightHandle (int)
void | SizeHandles () override
Protected Member Functions inherited from vtk3DWidget
| vtk3DWidget ()
| ~vtk3DWidget () override
void | AdjustBounds (double bounds[6], double newBounds[6], double center[3])
double | SizeHandles (double factor)
void | UpdateInput ()
Protected Member Functions inherited from vtkInteractorObserver
| vtkInteractorObserver ()
| ~vtkInteractorObserver () override
void | UnRegisterPickers ()
| Unregister internal pickers from the Picking Manager. More...
vtkPickingManager * | GetPickingManager ()
| Return the picking manager associated on the context on which the observer currently belong. More...
vtkAssemblyPath * | GetAssemblyPath (double X, double Y, double Z, vtkAbstractPropPicker *picker)
| Proceed to a pick, whether through the PickingManager if the picking is managed or directly using the picker, and return the assembly path. More...
int | RequestCursorShape (int requestedShape)
virtual void | StartInteraction ()
| Utility routines used to start and end interaction. More...
virtual void | EndInteraction ()
| Utility routines used to start and end interaction. More...
void | ComputeDisplayToWorld (double x, double y, double z, double worldPt[4])
| Helper method for subclasses. More...
void | ComputeWorldToDisplay (double x, double y, double z, double displayPt[3])
| Helper method for subclasses. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Static Protected Member Functions
static void | ProcessEvents (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
Static Protected Member Functions inherited from vtkInteractorObserver
static void | ProcessEvents (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
| Handles the char widget activation event. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Protected Attributes
int | State
vtkActor * | SphereActor
vtkPolyDataMapper * | SphereMapper
vtkSphereSource * | SphereSource
int | Representation
vtkCellPicker * | Picker
vtkTypeBool | Translation
vtkTypeBool | Scale
vtkProperty * | SphereProperty
vtkProperty * | SelectedSphereProperty
vtkProperty * | HandleProperty
vtkProperty * | SelectedHandleProperty
vtkActor * | HandleActor
vtkPolyDataMapper * | HandleMapper
vtkSphereSource * | HandleSource
vtkTypeBool | HandleVisibility
double | HandleDirection [3]
double | HandlePosition [3]
Protected Attributes inherited from vtk3DWidget
vtkProp3D * | Prop3D
vtk3DWidgetConnection * | ConnectionHolder
double | PlaceFactor
int | Placed
double | InitialBounds [6]
double | InitialLength
double | HandleSize
int | ValidPick
double | LastPickPosition [3]
Protected Attributes inherited from vtkInteractorObserver
int | Enabled
vtkCallbackCommand * | EventCallbackCommand
vtkCallbackCommand * | KeyPressCallbackCommand
float | Priority
bool | PickingManaged
vtkTypeBool | KeyPressActivation
char | KeyPressActivationValue
vtkRenderWindowInteractor * | Interactor
vtkRenderer * | CurrentRenderer
vtkRenderer * | DefaultRenderer
unsigned long | CharObserverTag
unsigned long | DeleteObserverTag
vtkObserverMediator * | ObserverMediator
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

3D widget for manipulating a sphere

This 3D widget defines a sphere that can be interactively placed in a scene.

To use this object, just invoke SetInteractor() with the argument of the method a vtkRenderWindowInteractor. You may also wish to invoke "PlaceWidget()" to initially position the widget. The interactor will act normally until the "i" key (for "interactor") is pressed, at which point the vtkSphereWidget will appear. (See superclass documentation for information about changing this behavior.) Events that occur outside of the widget (i.e., no part of the widget is picked) are propagated to any other registered obsevers (such as the interaction style). Turn off the widget by pressing the "i" key again (or invoke the Off() method).

The vtkSphereWidget has several methods that can be used in conjunction with other VTK objects. The Set/GetThetaResolution() and Set/GetPhiResolution() methods control the number of subdivisions of the sphere in the theta and phi directions; the GetPolyData() method can be used to get the polygonal representation and can be used for things like seeding streamlines. The GetSphere() method returns a sphere implicit function that can be used for cutting and clipping. Typical usage of the widget is to make use of the StartInteractionEvent, InteractionEvent, and EndInteractionEvent events. The InteractionEvent is called on mouse motion; the other two events are called on button down and button up (any mouse button).

Some additional features of this class include the ability to control the properties of the widget. You can set the properties of the selected and unselected representations of the sphere.

See also
  vtk3DWidget vtkLineWidget vtkBoxWidget vtkPlaneWidget

Events:
  vtkCommand::DisableEvent vtkCommand::EnableEvent vtkCommand::EndInteractionEvent vtkCommand::InteractionEvent vtkCommand::StartInteractionEvent

Online Examples:

Tests:
  vtkSphereWidget (Tests)

Definition at line 77 of file vtkSphereWidget.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtk3DWidget vtkSphereWidget::Superclass

Definition at line 85 of file vtkSphereWidget.h.

## Member Enumeration Documentation

## ◆ WidgetState

enum vtkSphereWidget::WidgetState
| protected

Enumerator
Start |
Moving |
Scaling |
Positioning |
Outside |

Definition at line 238 of file vtkSphereWidget.h.

## Constructor & Destructor Documentation

## ◆ vtkSphereWidget()

vtkSphereWidget::vtkSphereWidget | ( |  | ) |
| protected

## ◆ ~vtkSphereWidget()

vtkSphereWidget::~vtkSphereWidget | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkSphereWidget* vtkSphereWidget::New | ( |  | ) |
| static

Instantiate the object.

## ◆ IsTypeOf()

static vtkTypeBool vtkSphereWidget::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkSphereWidget::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtk3DWidget.

## ◆ SafeDownCast()

static vtkSphereWidget* vtkSphereWidget::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkSphereWidget::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtk3DWidget.

## ◆ NewInstance()

vtkSphereWidget* vtkSphereWidget::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkSphereWidget::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtk3DWidget.

## ◆ SetEnabled()

void vtkSphereWidget::SetEnabled | ( | int |  | ) |
| overridevirtual

Methods that satisfy the superclass' API.

Reimplemented from vtkInteractorObserver.

## ◆ PlaceWidget() [1/3]

void vtkSphereWidget::PlaceWidget | ( | double | bounds[6] | ) |
| overridevirtual

Methods that satisfy the superclass' API.

Implements vtk3DWidget.

## ◆ PlaceWidget() [2/3]

void vtkSphereWidget::PlaceWidget | ( |  | ) |
| inlineoverridevirtual

Methods that satisfy the superclass' API.

Reimplemented from vtk3DWidget.

Definition at line 94 of file vtkSphereWidget.h.

## ◆ PlaceWidget() [3/3]

void vtkSphereWidget::PlaceWidget | ( | double | xmin,
|  | double | xmax,
|  | double | ymin,
|  | double | ymax,
|  | double | zmin,
|  | double | zmax
| ) |  |
| inlineoverridevirtual

Methods that satisfy the superclass' API.

Reimplemented from vtk3DWidget.

Definition at line 95 of file vtkSphereWidget.h.

## ◆ SetRepresentation()

virtual void vtkSphereWidget::SetRepresentation | ( | int |  | ) |
| virtual

Set the representation of the sphere.

Different representations are useful depending on the application. The default is VTK_SPHERE_WIREFRAME.

## ◆ GetRepresentation()

virtual int vtkSphereWidget::GetRepresentation | ( |  | ) |
| virtual

Set the representation of the sphere.

Different representations are useful depending on the application. The default is VTK_SPHERE_WIREFRAME.

## ◆ SetRepresentationToOff()

void vtkSphereWidget::SetRepresentationToOff | ( |  | ) |
| inline

Set the representation of the sphere.

Different representations are useful depending on the application. The default is VTK_SPHERE_WIREFRAME.

Definition at line 110 of file vtkSphereWidget.h.

## ◆ SetRepresentationToWireframe()

void vtkSphereWidget::SetRepresentationToWireframe | ( |  | ) |
| inline

Set the representation of the sphere.

Different representations are useful depending on the application. The default is VTK_SPHERE_WIREFRAME.

Definition at line 111 of file vtkSphereWidget.h.

## ◆ SetRepresentationToSurface()

void vtkSphereWidget::SetRepresentationToSurface | ( |  | ) |
| inline

Set the representation of the sphere.

Different representations are useful depending on the application. The default is VTK_SPHERE_WIREFRAME.

Definition at line 112 of file vtkSphereWidget.h.

## ◆ SetThetaResolution()

void vtkSphereWidget::SetThetaResolution | ( | int | r | ) |
| inline

Set/Get the resolution of the sphere in the Theta direction.

The default is 16.

Definition at line 119 of file vtkSphereWidget.h.

## ◆ GetThetaResolution()

int vtkSphereWidget::GetThetaResolution | ( |  | ) |
| inline

Definition at line 120 of file vtkSphereWidget.h.

## ◆ SetPhiResolution()

void vtkSphereWidget::SetPhiResolution | ( | int | r | ) |
| inline

Set/Get the resolution of the sphere in the Phi direction.

The default is 8.

Definition at line 126 of file vtkSphereWidget.h.

## ◆ GetPhiResolution()

int vtkSphereWidget::GetPhiResolution | ( |  | ) |
| inline

Definition at line 127 of file vtkSphereWidget.h.

## ◆ SetRadius()

void vtkSphereWidget::SetRadius | ( | double | r | ) |
| inline

Set/Get the radius of sphere.

Default is .5.

Definition at line 133 of file vtkSphereWidget.h.

## ◆ GetRadius()

double vtkSphereWidget::GetRadius | ( |  | ) |
| inline

Set/Get the radius of sphere.

Default is .5.

Definition at line 141 of file vtkSphereWidget.h.

## ◆ SetCenter() [1/2]

void vtkSphereWidget::SetCenter | ( | double | x,
|  | double | y,
|  | double | z
| ) |  |
| inline

Set/Get the center of the sphere.

Definition at line 148 of file vtkSphereWidget.h.

## ◆ SetCenter() [2/2]

void vtkSphereWidget::SetCenter | ( | double | x[3] | ) |
| inline

Set/Get the center of the sphere.

Definition at line 149 of file vtkSphereWidget.h.

## ◆ GetCenter() [1/2]

double* vtkSphereWidget::GetCenter | ( |  | ) |
| inline

Set/Get the center of the sphere.

Definition at line 150 of file vtkSphereWidget.h.

## ◆ GetCenter() [2/2]

void vtkSphereWidget::GetCenter | ( | double | xyz[3] | ) |
| inline

Set/Get the center of the sphere.

Definition at line 151 of file vtkSphereWidget.h.

## ◆ SetTranslation()

virtual void vtkSphereWidget::SetTranslation | ( | vtkTypeBool |  | ) |
| virtual

Enable translation and scaling of the widget.

By default, the widget can be translated and rotated.

## ◆ GetTranslation()

virtual vtkTypeBool vtkSphereWidget::GetTranslation | ( |  | ) |
| virtual

Enable translation and scaling of the widget.

By default, the widget can be translated and rotated.

## ◆ TranslationOn()

virtual void vtkSphereWidget::TranslationOn | ( |  | ) |
| virtual

Enable translation and scaling of the widget.

By default, the widget can be translated and rotated.

## ◆ TranslationOff()

virtual void vtkSphereWidget::TranslationOff | ( |  | ) |
| virtual

Enable translation and scaling of the widget.

By default, the widget can be translated and rotated.

## ◆ SetScale()

virtual void vtkSphereWidget::SetScale | ( | vtkTypeBool |  | ) |
| virtual

Enable translation and scaling of the widget.

By default, the widget can be translated and rotated.

## ◆ GetScale()

virtual vtkTypeBool vtkSphereWidget::GetScale | ( |  | ) |
| virtual

Enable translation and scaling of the widget.

By default, the widget can be translated and rotated.

## ◆ ScaleOn()

virtual void vtkSphereWidget::ScaleOn | ( |  | ) |
| virtual

Enable translation and scaling of the widget.

By default, the widget can be translated and rotated.

## ◆ ScaleOff()

virtual void vtkSphereWidget::ScaleOff | ( |  | ) |
| virtual

Enable translation and scaling of the widget.

By default, the widget can be translated and rotated.

## ◆ SetHandleVisibility()

virtual void vtkSphereWidget::SetHandleVisibility | ( | vtkTypeBool |  | ) |
| virtual

The handle sits on the surface of the sphere and may be moved around the surface by picking (left mouse) and then moving.

The position of the handle can be retrieved, this is useful for positioning cameras and lights. By default, the handle is turned off.

## ◆ GetHandleVisibility()

virtual vtkTypeBool vtkSphereWidget::GetHandleVisibility | ( |  | ) |
| virtual

The handle sits on the surface of the sphere and may be moved around the surface by picking (left mouse) and then moving.

The position of the handle can be retrieved, this is useful for positioning cameras and lights. By default, the handle is turned off.

## ◆ HandleVisibilityOn()

virtual void vtkSphereWidget::HandleVisibilityOn | ( |  | ) |
| virtual

The handle sits on the surface of the sphere and may be moved around the surface by picking (left mouse) and then moving.

The position of the handle can be retrieved, this is useful for positioning cameras and lights. By default, the handle is turned off.

## ◆ HandleVisibilityOff()

virtual void vtkSphereWidget::HandleVisibilityOff | ( |  | ) |
| virtual

The handle sits on the surface of the sphere and may be moved around the surface by picking (left mouse) and then moving.

The position of the handle can be retrieved, this is useful for positioning cameras and lights. By default, the handle is turned off.

## ◆ SetHandleDirection() [1/2]

virtual void vtkSphereWidget::SetHandleDirection | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the direction vector of the handle relative to the center of the sphere.

The direction of the handle is from the sphere center to the handle position.

## ◆ SetHandleDirection() [2/2]

virtual void vtkSphereWidget::SetHandleDirection | ( | double | [3] | ) |
| virtual

Set/Get the direction vector of the handle relative to the center of the sphere.

The direction of the handle is from the sphere center to the handle position.

## ◆ GetHandleDirection() [1/3]

virtual double* vtkSphereWidget::GetHandleDirection | ( |  | ) |
| virtual

Set/Get the direction vector of the handle relative to the center of the sphere.

The direction of the handle is from the sphere center to the handle position.

## ◆ GetHandleDirection() [2/3]

virtual void vtkSphereWidget::GetHandleDirection | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Set/Get the direction vector of the handle relative to the center of the sphere.

The direction of the handle is from the sphere center to the handle position.

## ◆ GetHandleDirection() [3/3]

virtual void vtkSphereWidget::GetHandleDirection | ( | double | [3] | ) |
| virtual

Set/Get the direction vector of the handle relative to the center of the sphere.

The direction of the handle is from the sphere center to the handle position.

## ◆ GetHandlePosition() [1/3]

virtual double* vtkSphereWidget::GetHandlePosition | ( |  | ) |
| virtual

Get the position of the handle.

## ◆ GetHandlePosition() [2/3]

virtual void vtkSphereWidget::GetHandlePosition | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Get the position of the handle.

## ◆ GetHandlePosition() [3/3]

virtual void vtkSphereWidget::GetHandlePosition | ( | double | [3] | ) |
| virtual

Get the position of the handle.

## ◆ GetPolyData()

void vtkSphereWidget::GetPolyData | ( | vtkPolyData * | pd | ) |

Grab the polydata (including points) that defines the sphere.

The polydata consists of n+1 points, where n is the resolution of the sphere. These point values are guaranteed to be up-to-date when either the InteractionEvent or EndInteraction events are invoked. The user provides the vtkPolyData and the points and polysphere are added to it.

## ◆ GetSphere()

void vtkSphereWidget::GetSphere | ( | vtkSphere * | sphere | ) |

Get the spherical implicit function defined by this widget.

Note that vtkSphere is a subclass of vtkImplicitFunction, meaning that it can be used by a variety of filters to perform clipping, cutting, and selection of data.

## ◆ GetSphereProperty()

virtual vtkProperty* vtkSphereWidget::GetSphereProperty | ( |  | ) |
| virtual

Get the sphere properties.

The properties of the sphere when selected and unselected can be manipulated.

## ◆ GetSelectedSphereProperty()

virtual vtkProperty* vtkSphereWidget::GetSelectedSphereProperty | ( |  | ) |
| virtual

Get the sphere properties.

The properties of the sphere when selected and unselected can be manipulated.

## ◆ GetHandleProperty()

virtual vtkProperty* vtkSphereWidget::GetHandleProperty | ( |  | ) |
| virtual

Get the handle properties (the little ball on the sphere is the handle).

The properties of the handle when selected and unselected can be manipulated.

## ◆ GetSelectedHandleProperty()

virtual vtkProperty* vtkSphereWidget::GetSelectedHandleProperty | ( |  | ) |
| virtual

Get the handle properties (the little ball on the sphere is the handle).

The properties of the handle when selected and unselected can be manipulated.

## ◆ ProcessEvents()

static void vtkSphereWidget::ProcessEvents | ( | vtkObject * | object,
|  | unsigned long | event,
|  | void * | clientdata,
|  | void * | calldata
| ) |  |
| staticprotected

## ◆ OnLeftButtonDown()

void vtkSphereWidget::OnLeftButtonDown | ( |  | ) |
| protected

## ◆ OnLeftButtonUp()

void vtkSphereWidget::OnLeftButtonUp | ( |  | ) |
| protected

## ◆ OnRightButtonDown()

void vtkSphereWidget::OnRightButtonDown | ( |  | ) |
| protected

## ◆ OnRightButtonUp()

void vtkSphereWidget::OnRightButtonUp | ( |  | ) |
| protected

## ◆ OnMouseMove()

void vtkSphereWidget::OnMouseMove | ( |  | ) |
| protected

## ◆ HighlightSphere()

void vtkSphereWidget::HighlightSphere | ( | int | highlight | ) |
| protected

## ◆ SelectRepresentation()

void vtkSphereWidget::SelectRepresentation | ( |  | ) |
| protected

## ◆ RegisterPickers()

void vtkSphereWidget::RegisterPickers | ( |  | ) |
| overrideprotectedvirtual

Register internal Pickers in the Picking Manager.

Must be reimplemented by concrete widgets to register their pickers.

Reimplemented from vtkInteractorObserver.

## ◆ Translate()

void vtkSphereWidget::Translate | ( | double * | p1,
|  | double * | p2
| ) |  |
| protected

## ◆ ScaleSphere()

void vtkSphereWidget::ScaleSphere | ( | double * | p1,
|  | double * | p2,
|  | int | X,
|  | int | Y
| ) |  |
| protected

## ◆ MoveHandle()

void vtkSphereWidget::MoveHandle | ( | double * | p1,
|  | double * | p2,
|  | int | X,
|  | int | Y
| ) |  |
| protected

## ◆ PlaceHandle()

void vtkSphereWidget::PlaceHandle | ( | double * | center,
|  | double | radius
| ) |  |
| protected

## ◆ CreateDefaultProperties()

void vtkSphereWidget::CreateDefaultProperties | ( |  | ) |
| protected

## ◆ HighlightHandle()

void vtkSphereWidget::HighlightHandle | ( | int |  | ) |
| protected

## ◆ SizeHandles()

void vtkSphereWidget::SizeHandles | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from vtk3DWidget.

## Member Data Documentation

## ◆ State

int vtkSphereWidget::State
| protected

Definition at line 237 of file vtkSphereWidget.h.

## ◆ SphereActor

vtkActor* vtkSphereWidget::SphereActor
| protected

Definition at line 259 of file vtkSphereWidget.h.

## ◆ SphereMapper

vtkPolyDataMapper* vtkSphereWidget::SphereMapper
| protected

Definition at line 260 of file vtkSphereWidget.h.

## ◆ SphereSource

vtkSphereSource* vtkSphereWidget::SphereSource
| protected

Definition at line 261 of file vtkSphereWidget.h.

## ◆ Representation

int vtkSphereWidget::Representation
| protected

Definition at line 266 of file vtkSphereWidget.h.

## ◆ Picker

vtkCellPicker* vtkSphereWidget::Picker
| protected

Definition at line 269 of file vtkSphereWidget.h.

## ◆ Translation

vtkTypeBool vtkSphereWidget::Translation
| protected

Definition at line 275 of file vtkSphereWidget.h.

## ◆ Scale

vtkTypeBool vtkSphereWidget::Scale
| protected

Definition at line 276 of file vtkSphereWidget.h.

## ◆ SphereProperty

vtkProperty* vtkSphereWidget::SphereProperty
| protected

Definition at line 284 of file vtkSphereWidget.h.

## ◆ SelectedSphereProperty

vtkProperty* vtkSphereWidget::SelectedSphereProperty
| protected

Definition at line 285 of file vtkSphereWidget.h.

## ◆ HandleProperty

vtkProperty* vtkSphereWidget::HandleProperty
| protected

Definition at line 286 of file vtkSphereWidget.h.

## ◆ SelectedHandleProperty

vtkProperty* vtkSphereWidget::SelectedHandleProperty
| protected

Definition at line 287 of file vtkSphereWidget.h.

## ◆ HandleActor

vtkActor* vtkSphereWidget::HandleActor
| protected

Definition at line 291 of file vtkSphereWidget.h.

## ◆ HandleMapper

vtkPolyDataMapper* vtkSphereWidget::HandleMapper
| protected

Definition at line 292 of file vtkSphereWidget.h.

## ◆ HandleSource

vtkSphereSource* vtkSphereWidget::HandleSource
| protected

Definition at line 293 of file vtkSphereWidget.h.

## ◆ HandleVisibility

vtkTypeBool vtkSphereWidget::HandleVisibility
| protected

Definition at line 295 of file vtkSphereWidget.h.

## ◆ HandleDirection

double vtkSphereWidget::HandleDirection[3]
| protected

Definition at line 296 of file vtkSphereWidget.h.

## ◆ HandlePosition

double vtkSphereWidget::HandlePosition[3]
| protected

Definition at line 297 of file vtkSphereWidget.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkSphereWidget.h